name: Build and maybe upload PyPI package

on:
    push:
        branches: [main]
        tags: ["*"]
    pull_request:
        branches: [main]
    release:
        types: [published]
    workflow_dispatch:

env:
    FORCE_COLOR: "1" # Make tools pretty.

permissions:
    contents: read

jobs:
    # Always build and lint
    build-package:
        name: Build package 📦
        runs-on: ubuntu-latest

        steps:
            - name: "Checkout repository 🛎"
              uses: actions/checkout@v4
              with:
                fetch-depth: 0

            - name: "Build and inspect package 🛠"
              uses: hynek/build-and-inspect-python-package@v2

    # Upload to Test PyPI on every commit on main.
    release-test-pypi:
        name: Publish in-dev package to test.pypi.org
        environment: release-test-pypi
        permissions:
            id-token: write
        if: github.event_name == 'push' && github.ref == 'refs/heads/main'
        runs-on: ubuntu-latest
        needs: build-package

        steps:
            - name: "Download package built in previous job 📥"
              uses: actions/download-artifact@v4
              with:
                name: Packages
                path: dist
            - name: "Upload package to Test PyPI 🚀"
              uses: pypa/gh-action-pypi-publish@release/v1
              with:
                repository-url: https://test.pypi.org/legacy/

    # Upload to real PyPI on GitHub Releases.
    release-pypi:
        name: Publish released package to pypi.org 🚀
        environment:
            name: release-pypi
            url: https://pypi.org/project/accessible-pygments/
        permissions:
            id-token: write
        if: github.repository_owner == 'Quansight-Labs' && github.event_name == 'release' && startsWith(github.ref, 'refs/tags/')
        runs-on: ubuntu-latest
        needs: build-package

        steps:
            - name: "Download packages built in previous job 📥"
              uses: actions/download-artifact@v4
              with:
                name: Packages
                path: dist

            - name: "Upload package to PyPI 🚀"
              uses: pypa/gh-action-pypi-publish@release/v1
              with:
                print-hash: true
                verbose: true
